@file:Suppress("unused", "NOTHING_TO_INLINE")

package com.tencent.karaoketv.common.collections


/**
 * Copyright 2018 Tencent Inc. All Rights Reserved.
 * <p>
 * Detail: Arrays容器
 * <p>
 * Author: glensun
 * Create on 2018/3/20.
 */

/**
 * 遍历
 */
inline fun <T> Array<T>.forEachByIndex(f: (T) -> Unit) {
    val lastIndex = size - 1
    for (i in 0..lastIndex) {
        f(get(i))
    }
}

/**
 * 遍历
 */
inline fun <T> Array<T>.forEachWithIndex(f: (Int, T) -> Unit) {
    val lastIndex = size - 1
    for (i in 0..lastIndex) {
        f(i, get(i))
    }
}