@file:Suppress("unused", "NOTHING_TO_INLINE")

package com.tencent.karaoketv.common.collections

/**
 * Copyright 2018 Tencent Inc. All Rights Reserved.
 * <p>
 * Detail: List容器相关
 * <p>
 * Author: glensun
 * Create on 2018/3/20.
 */

inline fun <T> List<T>.forEachByIndex(f: (T) -> Unit) {
    val lastIndex = size - 1
    for (i in 0..lastIndex) {
        f(get(i))
    }
}

inline fun <T> List<T>.forEachWithIndex(f: (Int, T) -> Unit) {
    val lastIndex = size - 1
    for (i in 0..lastIndex) {
        f(i, get(i))
    }
}

/**
 * Java pair转Kotlin pair
 */
inline fun <F, S> android.util.Pair<F, S>.toKotlinPair(): Pair<F, S> = first to second

/**
 * Kotlin pair转Java pair
 */
inline fun <F, S> Pair<F, S>.toAndroidPair(): android.util.Pair<F, S> = android.util.Pair(first, second)