@file:Suppress("unused", "NOTHING_TO_INLINE")

package com.tencent.karaoketv.common.collections

import android.util.SparseArray
import android.util.SparseBooleanArray
import android.util.SparseIntArray
import java.util.*

/**
 * Copyright 2018 Tencent Inc. All Rights Reserved.
 * <p>
 * Detail: SparseArray
 * <p>
 * Author: glensun
 * Create on 2018/3/20.
 */

inline fun <T> SparseArray<T>.forEach(action: (Int, T) -> Unit) {
    val lastIndex = this.size() - 1
    for (i in 0..lastIndex) {
        if (lastIndex != this.size() - 1) throw ConcurrentModificationException()
        action(this.keyAt(i), this.valueAt(i))
    }
}

inline fun SparseBooleanArray.forEach(action: (Int, Boolean) -> Unit) {
    val lastIndex = this.size() - 1
    for (i in 0..lastIndex) {
        if (lastIndex != this.size() - 1) throw ConcurrentModificationException()
        action(this.keyAt(i), this.valueAt(i))
    }
}

inline fun SparseIntArray.forEach(action: (Int, Int) -> Unit) {
    val lastIndex = this.size() - 1
    for (i in 0..lastIndex) {
        if (lastIndex != this.size() - 1) throw ConcurrentModificationException()
        action(this.keyAt(i), this.valueAt(i))
    }
}