package com.tencent.karaoketv.utils

import android.annotation.SuppressLint
import com.tencent.karaoketv.common.account.UserManager
import com.tencent.karaoketv.common.network.wns.WnsStatisticAgent
import java.util.*

/**
 * Copyright 2017 Tencent Inc. All Rights Reserved.
 * <p>
 * Detail: 哈勃上报，上报数据，可以去这里看：
 * {http://habo.oa.com/viewmonitor/monitor?cmp_date=2017-11-22&cur_date=2017-11-23&date=2017-11-23&end_date=2017-11-23&end_time=23%3A59&groupby=appid&groupbyText=appid&index=succrate&indexText=%E6%88%90%E5%8A%9F%E7%8E%87&menuId=139&selectedKeys=monitor_139&start_date=2017-11-16&start_time=00%3A00&timePeriod=60&timePeriodText=1%E5%88%86%E9%92%9F}
 *
 * kotlin语言
 * <p>
 * Author: glensun
 * Create on 2017/11/23.
 */
object HubbleReporter {

    @SuppressLint("UseSparseArrays")
    fun report(cmd: String?, resultCode: Int) {
        report(cmd, resultCode, 0, true)
    }

    fun report(cmd: String?, resultCode: Int, costTime: Long, isFlushNow: Boolean) {

        if(cmd == null){
            throw HubbleNullCMDException("Null CMD is Illegal")
        }

        val currentStaticAgent = WnsStatisticAgent.getInstance()
        val params = HashMap<Int, Any>()
        params.put(WnsStatisticAgent.KEY_COMMAND_ID, cmd)
        params.put(WnsStatisticAgent.KEY_TO_UIN, UserManager.getInstance().currentUid)
        params.put(WnsStatisticAgent.KEY_RESULT_CODE, resultCode)
        params.put(WnsStatisticAgent.KEY_TIME_COST, costTime)
        currentStaticAgent.report(params)
        currentStaticAgent.forceDeliver()
        if (isFlushNow) {
            currentStaticAgent.flush()
        }
    }

    class HubbleNullCMDException(override val message:String) : Throwable()

}