package com.tencent.qqmusiccommon.util

import android.app.Activity
import android.content.Context
import android.support.annotation.StringRes
import android.support.v4.app.Fragment
import easytv.support.utils.TipToast
import ksong.support.utils.MusicToast

/**
 * Copyright 2018 Tencent Inc. All Rights Reserved.
 * <p>
 * Detail: 利用Kotlin扩展函数实现对[QQToast]的封装
 * <p>
 * Author: glensun
 * Create on 2018/1/8.
 */

/**
 * 展示Toast,默认展示时间是[Toast.LENGTH_SHORT]
 */
inline fun Fragment.qqToast(@StringRes idRes: Int, duration: Int = TipToast.LENGTH_SHORT) = context.qqToast(idRes, duration)

/**
 * 展示Toast,默认展示时间是[Toast.LENGTH_SHORT]
 */
inline fun Activity.qqToast(@StringRes idRes: Int, duration: Int = TipToast.LENGTH_SHORT) = baseContext.qqToast(idRes, duration)

/**
 * 展示Toast,默认展示时间是[Toast.LENGTH_SHORT]
 */
inline fun Context.qqToast(@StringRes idRes: Int, duration: Int = TipToast.LENGTH_SHORT) = qqToast(getString(idRes), duration)

/**
 * 展示Toast,默认展示时间是[Toast.LENGTH_SHORT]
 */
inline fun Fragment.qqToast(content: String?, duration: Int = TipToast.LENGTH_SHORT) = context.qqToast(content, duration)

/**
 * 展示Toast,默认展示时间是[Toast.LENGTH_SHORT]
 */
inline fun Activity.qqToast(content: String?, duration: Int = TipToast.LENGTH_SHORT) = baseContext.qqToast(content, duration)

/**
 * 展示Toast,默认展示时间是[Toast.LENGTH_SHORT]
 */
inline fun Context.qqToast(content: String?, duration: Int = TipToast.LENGTH_SHORT) {
    MusicToast.show(this, content, duration)
}
